Subject: bug#59833: 29.0.60; json-ts-mode fontifies everything as string

From: Randy Taylor <[email-masked]>
Date: Mon, 05 Dec 2022 14:42:37 +0000

On Monday, December 5th, 2022 at 09:12, Theodor Thornhill <[email-masked]> wrote:
> 
> 
> Randy Taylor [email-masked] writes:
> 
> > On Monday, December 5th, 2022 at 08:52, Randy Taylor [email-masked] wrote:
> > 
> > > On Monday, December 5th, 2022 at 06:24, Theodor Thornhill [email-masked] wrote:
> > > 
> > > > Jostein Kjønigsen [email-masked] writes:
> > > > 
> > > > > Hey everyone.
> > > > > 
> > > > > When opening a JSON-file in a build from emacs git emacs-29
> > > > > release-branch, Emacs still defaults to json-mode.
> > > > > 
> > > > > Fontification in json-mode looks correct and proper.
> > > > > 
> > > > > When trying to insteas use json-ts-mode, literally everything is
> > > > > fontified as strings.
> > > > > 
> > > > > When I change the code to disable the string-fontification rule, this
> > > > > yields a buffer where everything is fontified using default-face. That
> > > > > is, no other fontification is taking place.
> > > > > 
> > > > > Have this mode really been tested? Should it be working? Or is there an
> > > > > error on my end?
> > > > > 
> > > > > Could someone else please give json-ts-mode a try?
> > > > 
> > > > Yeah, you are correct. It seems we've had a regression in this commit,
> > > > 0ed313642227afdeccf48057eea458edca9d2962.
> > > > 
> > > > I believe this is the offending commit - what do you think, Randy?
> > > > 
> > > > Specifically the lhs should be fontified differently than the rhs, so
> > > > not everything is a string.
> > > > 
> > > > Do you want to do that, Randy, or should I?
> > > > 
> > > > Theo
> > > 
> > > Can someone show me an example JSON file that shows this problem? Everything looks the same for me in json-mode and json-ts-mode, except for the json-ts-mode extras (even with Theo's patch) both with my own Emacs config and emacs -Q. I must be doing something very silly.
> > 
> > Scratch that, I got Theo's patch working, needed to rebuild.
> 
> 
> No need to rebuild. Just C-M-x the defvar and revert buffer.

I was even restarting and it wasn't picking up the changes for some reason.

> 
> > Looks good to me (although it would be nice to keep treesit-font-lock-feature-list alphabetized Theo ;)).
> 
> 
> See new patch!

Thanks, I meant just the treesit-font-lock-feature-list variable :) (so moving pair before string).

Having the font-lock settings alphabetized too is great, but I remember running into some highlighting issues depending on the order of things.
For example, since error is above number, the number face will not be highlighted as error when an error occurs.

Try:
{
  "test": 2
}

and remove the colon. Before your patch, the entire line is red. After, only "test" is red.

So in general, I think we should stick all :overrides at the bottom of that list (with error being the ultimate one), and keep everything above and below alphabetized, but separately, which is how I organized json-ts-mode.

> 
> > json-mode still fontifies pretty much everything as a string though (at least for me).
> 
> 
> Not for me. I get number-face, bracket-face, constant-face,
> warning-face. Don't you?

Are you guys talking about the json-mode package? Jostein mentioned "Emacs still defaults to json-mode", but when I open a JSON file I get js-json-mode, which is what I assumed he meant. js-json-mode is what I was trying to match in json-ts-mode.

> 
> Will you commit this, Yuan?
> 
> Theo